<template>
  <v-flex>
    <v-flex xs12 class="text-end pt-3">
    <download-excel
        class="v-btn v-btn--flat v-btn--text theme--light v-size--default primary--text"
        :data="listPhoto"
        :fields="json_fields"
        worksheet="Dunlopillo"
        :name="`Final Customer PhotoList_${now}.xls`"
        >
        Export
    </download-excel>
      <v-btn text @click="logout" color="primary">logout</v-btn>
    </v-flex>
    <v-card>
      <v-container grid-list-md>
        <v-layout row wrap>
          <v-flex xs12 md6 lg3 v-for='n in listPhoto' :key='n.id'>
            <v-card
              max-width="344"
              class="mx-auto"
            >
              <v-img
                :src="mapPic(n.lastTransactions)"
                height="194"
              ></v-img>

              <v-card-actions >
                <v-layout row wrap>
                  <v-flex xs12>
                      <v-card-text class="a" >
                        Name : {{ n.fullName }} <br>
                        Mobile No. : {{ n.mobileNo }} <br>
                        E-mail : {{ n.email }} <br>
                        Update : {{lastDate(n.lastTransactions)}}
                      </v-card-text>
                      <v-divider class="mx-3"></v-divider>
                      <v-flex  class="text-xs-center">
                        <v-btn text color="primary" @click="showPic(n.lastTransactions)"><v-icon color="primary">fas fa-search-plus</v-icon>ZOOM</v-btn>
                        <v-btn text color="primary" @click="delPic(n)" ><v-icon color="primary" small>far fa-trash-alt</v-icon>Delete</v-btn>
                      </v-flex>
                  </v-flex>
                </v-layout>
              </v-card-actions>
            </v-card>
          </v-flex>
        </v-layout>
      </v-container>
    </v-card>
    <v-dialog v-model="dialog" persistent max-width="500">
        <v-card>
            <v-card-title class="headline">Are you sure to select out of this final customer photo lists ?</v-card-title>
            <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn color="green darken-1" text @click="updatePic()">Yes</v-btn>
            <v-btn color="green darken-1" text @click="dialog = false">No</v-btn>
            </v-card-actions>
        </v-card>
    </v-dialog>
  </v-flex>
</template>
<script>
import { fireStoreApp } from '@/firestore.init'
export default {
  created () {
    window.addEventListener('scroll', () => {
      this.bottom = this.bottomVisible()
      console.log(this.bottom)
    })
    let user = this.getUser()
    this.ref.listPhoto = fireStoreApp.collection('usersRegister').where('flagSelected', '==', true).orderBy(user, 'desc').limit(20)

    /* Load first page */
    const firstPage = this.ref.listPhoto.limit(this.paging.question_per_page)
    this.handleQuestions(firstPage)
  },
  data: () => ({
    listPhoto: [],
    bottom: false,
    selectedbtn: false,
    dialog: false,
    id: null,
    now: new Date(),

    paging: {
      question_per_page: 20,
      end: false,
      loading: false
    },
    ref: {
      listPhoto: null,
      listPhotoNext: null
    }
  }),
  methods: {
    updatePic () {
      let dataSet = {
        flagSelected: false
      }
      fireStoreApp.collection('usersRegister').doc(`${this.id}`).set(dataSet, { merge: true })
        .then(() => {
          window.location.reload()
        })
      this.dialog = false
    },
    delPic (n) {
      this.id = n.id
      this.dialog = true
    },
    changebtn (btn) {
      btn.flagSelected = true
      this.selectedbtn = true
      return btn
    },
    bottomVisible () {
      const scrollY = window.scrollY
      const visible = document.documentElement.clientHeight
      const pageHeight = document.documentElement.scrollHeight
      const bottomOfPage = visible + scrollY >= pageHeight

      return bottomOfPage || pageHeight < visible
    },
    loadMore () {
      if (this.paging.end) {
        return
      };

      this.paging.loading = true
      this.handleQuestions(this.ref.listPhotoNext).then((documentSnapshots) => {
        this.paging.loading = false

        if (documentSnapshots.empty) {
          /* If there is no more questions to load, set paging.end to true */
          this.paging.end = true
        }
      })
    },
    handleQuestions (ref) {
      return new Promise((resolve, reject) => {
        ref.get().then((documentSnapshots) => {
          /* If documentSnapshots is empty, then we have loaded all of pages */
          if (documentSnapshots.empty) {
            this.paging.end = true
            resolve(documentSnapshots)
          };

          documentSnapshots.forEach((doc) => {
            let questionData = doc.data()
            questionData.id = doc.id
            this.listPhoto.push(questionData)
          })

          /* Build reference for next page */
          const lastVisible = documentSnapshots.docs[documentSnapshots.size - 1]

          if (!lastVisible) {
            return
          };

          this.ref.listPhotoNext = this.ref.listPhoto
            .startAfter(lastVisible)
            .limit(this.paging.question_per_page)

          resolve(documentSnapshots)
        })
      })
    },
    mapPic (pic) {
      if (pic) {
        return pic[0].rawPicUrl
      }
      return ''
    },
    getUser () {
      let ranN
      let user = this.$store.getters['userReport/getUsername']
      if (user === 'committee01@dunlopillothai.com') {
        ranN = 'randomRef1'
      } else if (user === 'committee02@dunlopillothai.com') {
        ranN = 'randomRef2'
      } else {
        ranN = 'randomRef3'
      }
      return ranN
    },
    lastDate (time) {
      if (time) {
        let lastSeconds = time[0].createAt.seconds
        let Fdate = new Date(0)
        Fdate.setSeconds(lastSeconds)
        let day = Fdate.getDate()
        let month = Fdate.getMonth() + 1
        let year = Fdate.getFullYear()
        let hour = Fdate.getHours()
        let min = Fdate.getMinutes()
        let second = Fdate.getSeconds()
        let dateShow = [year, month, day].join('-')
        // let time = [hour, min, second].join(':')
        let dateTime = dateShow + ' ' + hour + ':' + min + ':' + second
        return dateTime
      }
      return ''
    },
    showPic (pic) {
      if (pic) {
        window.open(pic[0].rawPicUrl, '_blank')
      }
    },
    logout () {
      this.$store.dispatch('userReport/logout')
    }
  },
  watch: {
    bottom (bottom) {
      if (bottom) {
        this.loadMore()
      }
    }
  },
  computed: {
    json_fields () {
      let Dates = {
        'Name-Surname': 'fullName',
        'Mobile No.': {
          field: 'mobileNo',
          callback: (value) => {
            return `'${value}`
          }
        },
        'E-mail': 'email',
        'Latest Updated Date': {
          field: 'lastTransactions',
          callback: (value) => {
            if (value) {
              let a = value.map(x => x.createAt.seconds)
              console.log('1', a)
              let Fdate = new Date(0)
              Fdate.setSeconds(a[0])
              let day = Fdate.getDate()
              let month = Fdate.getMonth() + 1
              let year = Fdate.getFullYear()
              let dateShow = [year, month, day].join('-')
              return `${dateShow}`
            }
          }
        },
        'Count Updated': 'picCount',
        'Contest Picture': {
          field: 'lastTransactions',
          callback: (value) => {
            if (value.length > 0) {
              return `${value[0].rawPicUrl}`
            } else {
              return ''
            }
          }
        }
      }
      return Dates
    }
  }
}
</script>
<style>
div.a {
  white-space: nowrap;
  width: 250px;
  overflow: hidden;
  text-overflow:ellipsis;
}

div.a:hover {
  overflow: visible;
}
loading {
  text-align: center;
  position: absolute;
  color: #fff;
  z-index: 9;
  background: #5c4084;
  padding: 8px 18px;
  border-radius: 5px;
  left: calc(50% - 45px);
  top: calc(50% - 18px);
}
</style>
